// DeHackEd version 2.3
// Written by Greg Lewis, gregl@umich.edu
// If you release any versions of this code, please include
// the author in the credits.  Give credit where credit is due!

// Function prototypes for playview.cpp
int  Play(ResourceS entry);
int  Playsound(long soundnum);

// From dheinit.h
extern FILE *doomwadfp;
extern long (*framedata )[FRAME_FIELDS];
extern long (*sounddata )[SOUND_FIELDS];

// From dehacked.cpp
extern void AbortProg(char *func);

// From screen.h
extern char *pscreen;

// From screen.cpp
extern void clsMCGA(void);
extern void DisplayPic( int x0, int y0, int x1, int y1, char *picname);
extern void MCGAPutsXY (int x, int y, char *string, unsigned char col);
extern void setpalette(unsigned char palette[768]);
extern void toMCGA(void);
extern void totext(void);

// From print.cpp
extern void Getframename(int framenum, char *string);
extern void Getsoundname(int soundnum, char *string);
extern void Printwindow(char *message, int type);

// From files.cpp
extern int Searchforentry(char *name, ResourceS *entry);

// From input.cpp
extern EBool Waitforevent(EBool eatevent);

#ifdef HAVE_MOUSE
// From mouse.cpp
extern EBool getLastEvent(unsigned *x, unsigned *y, EButton *left_button,
								  EButton *right_button);

// Variables from mouse.h
extern unsigned eventButtons;
extern unsigned LastEventButtons;
#endif /* HAVE_MOUSE */


// Structures, defines, and variables specific to playing sounds and
// displaying pic resources.

// The header for the image data
struct frame_header {
        short width;                 /* Picture width */
        short height;                /* Picture height */
        short l_offset;              /* Left offset from center (unused?) */
        short t_offset;              /* Top offset from center (unused?) */
        };


#define SND_MAGIC	3
struct snd_header {
	unsigned short magic;		/* The magic number 3 */
	unsigned short sample_rate;	/* The sample rate (11025) */
	unsigned short num_samples;	/* The number of samples */
	unsigned short zero;		/* Null integer */
	};

#define _PATH_DEVAUDIO	"/dev/audio"

// From snd2au.cpp
extern unsigned int sample_cvt(int ch);
