
#ifndef X11_Keyboard_h
#define X11_Keyboard_h

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>

// This module provides uniform access to the keyboard through a
// variety of interfaces

class X11_Keyboard : public TTY_Keyboard {

public:
	X11_Keyboard(Display** D);

	virtual int raw(int newstate);
	virtual int pending_input(float do_wait);
	virtual int getch(void);

protected:
	virtual int  ExtendKey(KeySym key);

	Display **display;
	Window  mainwin;
	int width, height;
	GC  gc;
	KeySym  extended;
};
#endif
